using System.Collections;
using System.Collections.Generic;
using DefaultNamespace;
using UnityEngine;
using UnityEngine.UI;

public class ButtonManager
{
    [SerializeField] private AudioClip sfxClick;
    public enum ButtonID
    {
        FIRST,
        SECOND,
        THIRD
    }
    private Button _firstButton, _secondButton, _thirdButton;
    private GameManager _manager;
    private AudioManager _audioManager;
    private int DrunkCounter = 0;
    private int GoldCounter = 0;
    private bool HasEquipment = false;
    private bool HasFixedEquipment = false;
    private bool HasDynamite = false;
    // Start is called before the first frame update
    
    public ButtonManager(Button firstButton, Button secondButton, Button thirdButton, GameManager manager)
    {

        _firstButton = firstButton;
        _secondButton = secondButton;
        _thirdButton = thirdButton;

        _manager = manager;
        
        // Listeners for each Button
        _firstButton.onClick.AddListener(SendToRightState_First);
        _secondButton.onClick.AddListener(SendToRightState_Second);
        _thirdButton.onClick.AddListener(SendToRightState_Third);
        
    }
    
    // all of these also need to put you in
    void SendToRightState_First()
    {
        // renders the right state on screen
        // _gameLogic.DisplayState(GameState.);
        
        // something, help
        _manager.HandleButtonPress(ButtonID.FIRST);
        
    }

    void SendToRightState_Second()
    {
        // renders the right state on screen
        _manager.HandleButtonPress(ButtonID.SECOND);
    }

    void SendToRightState_Third()
    {
        // renders the right state on screen
        _manager.HandleButtonPress(ButtonID.THIRD);
    }
    

    public void ChangeBackground()
    {
        
    }
    // getter
    public int GetDrunkCounter()
    {
        return DrunkCounter;
    }
    public int GetGoldCounter()
    {
        return GoldCounter;
    }
    public bool GetHasEquipment()
    {
        return HasEquipment;
    }
    public bool GetHasFixedEquipment()
    {
        return HasFixedEquipment;
    }
    public bool GetHasDynamite()
    {
        return HasDynamite;
    }
    
    // setter
    public void SetHasEquipment(bool newValue)
    {
        HasEquipment = newValue;
    }
    public void SetHasFixedEquipment(bool newValue)
    {
        HasFixedEquipment = newValue;
    }
    public void SetHasDynamite(bool newValue)
    {
        HasDynamite = newValue;
    }
}