﻿using System.Collections.Generic;
using UnityEngine;

namespace DefaultNamespace
{
    public class Choice
    {
        
        public enum DisplayLayout
        {
            THREE, 
            TWO, 
            ONE
        }
        
        private readonly string _storyText;
        private readonly List<string> _options;
        private readonly DisplayLayout _displayLayout;
        
        public Choice(string storyText, List<string> options)
        {
            List<string> options1;
            this._storyText = storyText;
            this._options = options;
            
            switch (options.Count)
            {
                case 1:
                    _displayLayout = DisplayLayout.ONE;
                    break;
                case 2:
                    _displayLayout = DisplayLayout.TWO;
                    break;
                default:
                    _displayLayout = DisplayLayout.THREE; 
                    break;
            }
        }

        public string GetStoryText()
        {
            return _storyText;
        }

        public List<string> GetOptions()
        {
            return _options;
        }

        public DisplayLayout GetLayout()
        {
            return _displayLayout;
        }
    }
}