using System.Collections.Generic;
using UnityEngine.Networking;
using UnityEngine.Timeline;

namespace DefaultNamespace.Story
{
    public class GameStory
    {
        private GameLogic _gameLogic;
        public GameStory(GameLogic gameLogic)
        {
            _gameLogic = gameLogic;
        }
        public Choice DisplayState(GameState gameState)
        {
            switch (gameState)
            {
                case GameState.ENTRANCE:
                    return new Choice(
                        "\"Good morrow, friend! 'Tis another day delvin' in the mines, aye? Make fer yer locker and fetch yer gear, then we'll get this day started proper!\"", 
                        new List<string>() { "Go to mines", "Go to lockers", "Go to bar"});
               // case GameState.ENTRANCENOEQUIP:
                  //  return new Choice("");
                case GameState.ENTRANCEAGAIN:
                    return new Choice(
                        "\"Oi, laddie! What ye be doin'? Hurry up and start yer shift, will ye? We ain't got all day for lollygaggin'!\"",
                        new List<string>() { "Go to mines", "Go to lockers", "Go to bar" });
                case GameState.ENTRANCEBROKEN:
                    return new Choice(
                        "\"Hold yer horses, laddie! Ye won't be doin' nothin' with that busted equipment. Ye better get someone to take a look at it, or ye'll be up to yer neck in trouble!\"",
                        new List<string>() { "Go to mines", "Go to locker","Go to bar" });
                case GameState.ENTRANCEFIXED:
                    return new Choice(
                        "\"Aye, now ye look like a proper dwarf! Get on yer way and don't ye even think 'bout coming' back till ye got yer quota o' three gold chunks. Ye best be making' us proud, laddie!\"",
                        new List<string>() { "Go to mines", "Go to locker", "Go to bar" });
                case GameState.ENTRANCEAFTERSHIFT:
                    return new Choice(
                        "\"Done with yer shift, aye? Get yerself a drink or two and end this day proper, brother!\"",
                        new List<string>(){"Leave", "Go to Bar"});
                case GameState.ENTRANCETRY:
                    return new Choice(
                        "\"The hell ye tryin' to do? Yer in no shape to go into the mines.\"",
                        new List<string>(){"Go to mines", "Go to locker", "Go to bar"});
                case GameState.LOCKER:
                    return new Choice(
                        "Ye've found yer way to the locker room. Do ye recall the time when ye were stuck in yer locker, trying to fetch yer pickaxe and helmet? A right proper dwarf in distress, ye were!",
                        new List<string>() { "Go to your locker", "Go to entrance"});
                case GameState.LOCKERGETEQUIP:
                    return new Choice(
                        "Ye fetch yer trusty pickaxe and other mining gear, but they sure have seen better days. They won't be of any help in this condition.",
                        new List<string>() { "Go back to entrance" });
                case GameState.LOCKERHASEQUIP:
                    return new Choice(
                        "Ye've found yer way to the locker room. Do ye recall the time when ye were stuck in yer locker, trying to fetch yer pickaxe and helmet? A right proper dwarf in distress, ye were!",
                        new List<string>() {"Go to entrance"});
                case GameState.SMITH:
                    return new Choice(
                        "It's hotter than the furnaces of Khazad-dûm in here! Equipment scattered all o'er the place and dust thick as a dragon's hide. Ye best be getting a move on and get outta here sharpish before ye melt away like the mithril in that forge.",
                        new List<string>() { "Get your pickaxe fixed", "Talk to blacksmith", "Go to bar" });
                case GameState.SMITHNOEQUIP:
                    return new Choice(
                        "It's hotter than the furnaces of Khazad-dûm in here! Equipment scattered all o'er the place and dust thick as a dragon's hide. Ye best be getting a move on and get outta here sharpish before ye melt away like the mithril in that forge.",
                        new List<string>() { "Talk to blacksmith", "Go to bar" });
                case GameState.SMITHHASFIXED:
                    return new Choice("It's hotter than the furnaces of Khazad-dûm in here! Equipment scattered all o'er the place and dust thick as a dragon's hide. Ye best be getting a move on and get outta here sharpish before ye melt away like the mithril in that forge.",
                    new List<string>() {"Talk to blacksmith", "Go to bar"});
                case GameState.SMITHFIXED:
                    return new Choice(
                        "\"Give ye gear better care, would ye? It ain't easy fixing' things all the time. Anyway, it's fixed now, so keep on minin' away, brother!\"",
                        new List<string>() { "Talk to blacksmith", "Go to bar" });
                case GameState.SMITHTALK:
                    return new Choice(
                        "\"If ye be wasting time instead of workin', do it in a way that doesn't slow down those of us who actually have work to do, ye lazy bum.\"",
                        new List<string>() { "Go to bar" });
                
                case GameState.MINES: 
                    return new Choice(
                        "Several ages of dwarves have travelled through these mines. Ye can practically feel the presence of yer ancestors guidin' ye.",
                        new List<string>(){"Go left", "Go straight ahead", "Go right"}); // need to fix
                case GameState.MINESAFTER:
                    return new Choice(
                        "Several ages of dwarves have travelled through these mines. Ye can practically feel the presence of yer ancestors guidin' ye.",
                        new List<string>(){"Go left", "Return to Entrance", "Go right"});
                case GameState.MINESAFTERTRY:
                   return new Choice(
                    "Yer shift ain't done yet.",
                        new List<string>(){"Go left", "Return to Entrance", "Go right"});
                case GameState.ABANDONED_LAIR:
                    return new Choice("Ye can tell at a first glance that this room hasn't seen a soul in ages. Boxes and crates are scattered about and ye practically breathe more dust than air. The shelve look like they could collapse any moment, best be careful not to bump into them.", 
                        new List<string>(){"Search area", "Go back to jungle"});
                case GameState.ABANDONED_LAIRNOSEARCH:
                    return new Choice("Naught here that'll be of use to ye right now",
                        new List<string>() { "Go back to jungle" });
                case GameState.ABANDONED_LAIRSEARCHFIND:
                    return new Choice(
                        "After shovin' some crates around, ye've gone and found herself some TNT! This should do the trick.",
                        new List<string>() { "Go back to jungle" });
                case GameState.ABANDONED_LAIRTNT:
                    return new Choice("Ye can tell at a first glance that this room hasn't seen a soul in ages. Boxes and crates are scattered about and ye practically breathe more dust than air. The shelve look like they could collapse any moment, best be careful not to bump into them.", 
                        new List<string>(){"Search area", "Go back to jungle"});
                case GameState.BLOCKED_PATH:
                    return new Choice(
                        "This path be blocked tighter than a dwarf's purse after a night of heavy drinking. Ye'll have ta find a way to clear it if ya want ta forge ahead.",
                        new List<string>() {"Go back to mines"});
                case GameState.BLOCKED_PATHTNT:
                    return new Choice("The TNT ye found sure did the trick. The way ahead is now open! Well done, lad.",
                        new List<string>() { "Go further down"});
                case GameState.BLOCKED_PATHUSETNT:
                    return new Choice(
                        "This path be blocked tighter than a dwarf's purse after a night of heavy drinking. Ye'll have ta find a way to clear it if ya want ta forge ahead.",
                        new List<string>() {"Use TNT", "Go back to mines"});
                case GameState.JUNGLE:
                    return new Choice("Greens thicker than any ordinary forest block yer sight, promisin' a hard time to find a path through.",
                        new List<string>() { "Look for gold", "Go back to mines", "Go further into jungle" });
                case GameState.JUNGLEGOLD:
                    return new Choice(
                        "Looks like there was something worth digging for under all that muck and weeds. Ye find a gold vein lying under layers of greens! Ye receive one gold chunk.",
                        new List<string>() { "Go back to mines", "Go further into jungle" });
                case GameState.JUNGLEAFTERGOLD:
                    return new Choice(
                        "Greens thicker than any ordinary forest block yer sight, promisin' a hard time to find a path through.",
                        new List<string>() { "Go back to mines", "Go further into jungle" });
                
                case GameState.WATERFALL:
                    return new Choice(
                        "A majestic waterfall comes into sight, with water clearer than anythin' ye could find above ground.", 
                        new List<string>() { "Take a swim", "Look for gold", "Go back to mines" });
                case GameState.WATERFALLGOLD:
                    return new Choice(
                        "Ye find a hidden gold vein behind the waterfall! Ye receive one gold chunk.",
                        new List<string>() { "Go back to mines", "Take a swim" });
                case GameState.WATERFALLAFTERGOLD:
                    return new Choice(
                        "A majestic waterfall comes into sight, with water clearer than anythin' ye could find above ground.",
                        new List<string>() { "Take a swim", "Go back to mines" });
                case GameState.WATERFALLSWIM:
                    return new Choice(
                        "The water feels just as good as it looks. After a quick dip, ye feel fresher than ever.",
                        new List<string>() { "Go back to mines" });
                
                case GameState.BAR:
                    return new Choice(
                        "\"Welcome to the tavern! Isn't tad early fer a drink. Ha, who am I foolin'? Grab a seat and let's wet our whistles. It's never too soon for a good ale!\"",
                        new List<string>() { "Drink", "Go to blacksmith", "Go to entrance" });
                case GameState.BARDRINK1:
                    return new Choice("\"Good boy! Thirsty for another, are ye? Drink up!\"",
                        new List<string>() { "Drink", "Go to blacksmith", "Go to entrance" });
                case GameState.BARDRINK5:
                    return new Choice(
                        "\"Alright, that should be enough. Ye best be a responsible dwarf now and get to work. Get crackin' and make us proud!\"",
                        new List<string>() { "Go to blacksmith", "Go to entrance" });
                case GameState.BARAFTERSHIFT:
                    return new Choice("\"Ah, finished yer quota already, have ye? Well done lad! Take a seat and have a drink on us. Ye've earned it, and we're mighty proud of ye!\"",
                        new List<string>() { "Drink", "Go to entrance" });
                case GameState.BARAFTERSHIFTDRINK1:
                    return new Choice("\"Bottoms up!\"", 
                        new List<string>() { "Drink", "Go to entrance" });
                case GameState.BARAFTERSHIFTDRINK5:
                    return new Choice("\"Heh, can't walk a straight line now, can ye? Well, enough's enough. Go on home and be a family man!\"", 
                        new List<string>() { "Go to entrance" });
                
                case GameState.INSECTKING:
                    return new Choice(
                        "After some time ye find yourself in what appears to be an abhorrent looking throne room. A shiver runs down yer spine, as if the very stones of the the room be cursing yer presence.",
                        new List<string>() {"Continue"});
                case GameState.INSECTKING1:
                    return new Choice(
                        "\"You there, dwarf. Usually I would kill your kind the instant it dared walking in the same space as me. But today I'll make an exception.\"",
                        new List<string>() {"Continue"});
                case GameState.INSECTKING2:
                    return new Choice(
                        "One most foulest insect stands before you. Better be on yer guard.",
                        new List<string>() {"Continue"});
                case GameState.INSECTKING3:
                    return new Choice(
                        "\"You would do best to repay the mercy I show you. Let's strike a deal.\"",
                        new List<string>() {"Continue"});
                case GameState.INSECTKING4:
                    return new Choice(
                        "Betray your kind. For years you have pestered us, destroying our home for your unsatisfiable greed. But enough is enough.",
                        new List<string>() {"Continue"});
                case GameState.INSECTKING5:
                    return new Choice(
                        "\"Look into your heart and tell me dwarf: Is it as rocken as like the rest of your kind, or do you know kindness for an exception? Will you join our cause?\"",
                        new List<string>() {"\"'S the beer good?\""});
                case GameState.INSECTKING6:
                    return new Choice(
                        "\"? We have alcohol-free beer.\"",
                        new List<string>() {"\"I'll make an exception\"","\"Ya tree-climbing sissy\""});
                case GameState.INSECTKING7:
                    return new Choice("Ye call on his bluff an' ye go past him, with yer trusty pickaxe in hand.", 
                    new List<string>(){"Continue"});
                case GameState.INSECTKING8:
                    return new Choice(
                        "Determined ye move towards the glimmerin' gold vein that caught' yer attention.",
                        new List<string>() {"Continue"});
                case GameState.INSECTKING9:
                    return new Choice(
                        "With each strike a strong echo resounds and at last, ye have a gold chunk in yer hands.",
                        new List<string>() {"Continue"});
                case GameState.INSECTKING10:
                    return new Choice(
                        "As you leave the throne room you can hear a faint \"I'll remember this, you accursed dwarf\".",
                        new List<string>() {"Continue"});
                case GameState.INSECTKING11:
                    return new Choice(
                        "\"I'm not sure If I follow you but I'll take that as a yes.\"",
                        new List<string>() {"Continue"});
                case GameState.INSECTKING12:
                    return new Choice(
                        "Fantastic, with you at our side, Victory surely will be ours!",
                        new List<string>() {"Continue"});
                case GameState.ENDING1:
                    return new Choice(
                        "You betray your kind and join sides with the insects, resulting the death of all other dwarfs and your family. You live the rest of your life, alone, sad and dangerously sober",
                        new List<string>() {"End"});
                case GameState.ENDING2:
                    return new Choice(
                        "Ye successfully ended yer shift and spend the rest of the day with yer family.",
                        new List<string>() {"End"});
                case GameState.ENDING3:
                    return new Choice(
                        "Because of yer reckless drinking habits, yer family leaves you. Ye spend the rest of yer days after yer shift at the bar with only the company of yer drinks.",
                    new List<string>() {"End"});
                default:
                    return new Choice("", new List<string>(){});
            }
        }
    }
}